#!/bin/flua -f

-- (c) 2005 Robert Shingledecker
-- DSL Calendar View/Edit/Enter Events

dofile("/etc/init.d/functions.lua")

function showCurrentEvents()
   target = year..month_num
   for i = 1, selector.size do
      if strsub(selector:text(i),1,6)==target then
         selector:show(i)
      else
         selector:hide(i)
      end
   end
end

function saveEvents()
   local eventitems,err = openfile(eventfile,"w")
   if not eventitems then
      print("Impossibile aprire il file "..eventfile..":"..err)
      exit(1)
   end
   for i = 1, selector.size do
      if selector:text(i) ~= "" then
         write(eventitems,selector:text(i).."\n")
      end
   end
   closefile(eventitems)
   saveNeededFlag = nil
end

-- Main

saveNeededFlag = nil
window_width = 280
window_height = 300

eventfile = "/home/dsl/Events"
currentEvents = tmpname()
monthName={"Gennaio","Febbraio","Marzo","Aprile","Maggio","Giugno","Luglio","Agosto","Settembre","Ottobre","Novembre","Dicembre"}
month_num = date("%m")
year = date("%Y")

main = Window{window_width,window_height,"DSL Calendario Eventi"}
separatorBtm=Box{1,window_height-50,window_width-2,8,"@line"; labeltype=Labeltype.symbol}
separatorTop=Box{1,38,window_width-2,8,"@line"; labeltype=Labeltype.symbol}
function main:callback()
   if saveNeededFlag then
      response = fl_ask("Gli eventi sono stati cambiati!\nVuoi uscire senza salvare?")
      if response == 1 then
         exit(0)
      end
   else
      exit(0)
   end
end

month= Output{10,10,150,25;box=Boxtype.flat,color=Color.gray}
month.value = monthName[tonumber(month_num)].." "..year
month_down = Button{165,10,25,25;labeltype=Labeltype.symbol, label="@<"}
function month_down:callback()
   month_num = month_num - 1
   if month_num < 1 then 
      month_num = 12
      year = year - 1
   end
   month_num = format("%02u",month_num)
   month.value = monthName[tonumber(month_num)].." "..year
   showCurrentEvents()
end
month_up = Button{190,10,25,25;labeltype=Labeltype.symbol, label="@>"}
function month_up:callback()
   month_num = month_num + 1
   if month_num > 12 then 
      month_num = 1
      year = year + 1
   end
   month_num = format("%02u",month_num)
   month.value = monthName[tonumber(month_num)].." "..year
   showCurrentEvents()
end

viewBtn = Button{210,10,70,25,"Visualizza"}
function viewBtn.callback()
   if saveNeededFlag then saveEvents() end
   if fl_ask("Visualizza Landscape. Consigliabile x la stampa") == 1 then
      landscape = ""
   else
      landscape = "-R"
   end
   workfile = tmpname()
   execute('pscal '..landscape..' '..month_num..' '..year..'  >  '.. workfile)
   execute('/usr/local/bin/gvu ' .. workfile) 
   remove(workfile)
end

selector = Select_Browser{0,50,275,200; type=Browsertype.hold}
function selector:callback()
   selected_item = selector:text(self.value)
end
if not selector:load(eventfile) then
   print("impossibile caricare ", currentEvents)
   exit(1)
end
showCurrentEvents()

helpBtn = Button{10,window_height-35,50,25,"Help"}
function helpBtn.callback()
   fl_message(
"Gli eventi consistono in brevi testi di \n"..
"20 caratteri. Ogni giorno ne pu avere fino a 6 \n"..
"eventi o un singolo evento fino a 6 linee o \n"..
"una combinazione.")
end

editBtn = Button{60,window_height-35,50,25,"Edit"}
function editBtn.callback()
   if selector.value == 0 then
      fl_alert("Devi selezionare un evento!")
   else
      if selected_item ~= nil then 
         dayNbr = strsub(selected_item,4,5)
	 editEventWin.label = "Edit "..month.value.." "..dayNbr.." Event"
         event_edit.value = strsub(selected_item,7)
      end
      main:hide()
      editEventWin:show()
   end
end

newBtn = Button{110,window_height-35,50,25,"Nuovo"}
function newBtn.callback()
   addEventWin.label = "Agguingi un evento x "..month.value
   main:hide()
   addEventWin:show()
end

delBtn = Button{160,window_height-35,50,25,"Cancella"}
function delBtn.callback()
   if selector.value == 0 then
      fl_alert("Devi sezionare un evento!")
   else
      selector:remove(selector.value)
      saveNeededFlag = 1
   end
end

saveBtn = Button{210,window_height-35,50,25,"Salva"}
function saveBtn.callback()
   saveEvents()
   exit(0)
end

-------------- addEventWidow ---------------------

addEventWin = Window{250,120, " Nuovo Evento"}
function addEventWin:callback()
   addEventWin:hide()
   main:show()
end

day_input = Input{60,20,50,25,"Giorno:"}
day_input.value="04"
day_down = Button{120,20,25,25;labeltype=Labeltype.symbol, label="@<"}
function day_down:callback()
   day_num = tonumber(day_input.value) - 1
   if day_num < 1 then day_num = 31 end
   day_input.value = format("%02u",day_num)
end
day_up = Button{145,20,25,25;labeltype=Labeltype.symbol, label="@>"}
function day_up:callback()
   day_num = tonumber(day_input.value) + 1
   if day_num > 31 then day_num = 1 end
   day_input.value = format("%02u",day_num)
end

event_input = Input{60,50,170,25,"Evento:"}

ok = Button{60,80,70,25,"&OK"}
function ok:callback()
  if event_input.value ~= "" then
     newdata = year..month_num..":"..day_input.value..":"..event_input.value 
     if selector.value == 0 then
        selector:add(newdata)
        saveNeededFlag = 1
     else
        selector:insert(selector.value,newdata)
        saveNeededFlag = 1
     end
  end
  addEventWin:hide()
  main:show()
end

addEventWin:end_layout()

-------------- editEventWidow ---------------------

editEventWin = Window{250,70, "Edita evento"}
function editEventWin:callback()
   editEventWin:hide()
   main:show()
end

event_edit = Input{60,10,170,25,"Evento:"}

editok = Button{60,40,30,25,"&OK"}
function editok:callback()
  if event_edit.value ~= "" then
     newdata = month_num..":"..dayNbr..":"..event_edit.value 
     selector:set_text(selector.value,newdata)
     saveNeededFlag = 1
  end
  editEventWin:hide()
  main:show()
end

editEventWin:end_layout()

---------------------------------------------------

selector.position = 0
main.resizable = main
main:show()
