#!/bin/flua
-- (c) 2005 Robert Shingledecker <robert@damnsmalllinux.org> 
-- GUI frontend to the date and hwclock commands

w = Window{200,200, "Strumento x data"}

year_input = Input{60,10,50,25,"Anno:"}
year_input.value=date("%Y")
year_down = Button{120,10,25,25;labeltype=Labeltype.symbol, label="@<"}
function year_down:callback()
   year_input.value = year_input.value - 1
end
year_up = Button{150,10,25,25;labeltype=Labeltype.symbol, label="@>"}
function year_up:callback()
   year_input.value = year_input.value + 1
end

month_input = Input{60,40,50,25,"Mese:"}
month_input.value=date("%m")
month_down = Button{120,40,25,25;labeltype=Labeltype.symbol, label="@<"}
function month_down:callback()
   month_num = tonumber(month_input.value) - 1
   if month_num < 1 then month_num = 12 end
   month_input.value = format("%02u",month_num)
end
month_up = Button{150,40,25,25;labeltype=Labeltype.symbol, label="@>"}
function month_up:callback()
   month_num = tonumber(month_input.value) + 1
   if month_num > 12 then month_num = 1 end
   month_input.value = format("%02u",month_num)
end

day_input = Input{60,70,50,25,"Giorno:"}
day_input.value=date("%d")
day_down = Button{120,70,25,25;labeltype=Labeltype.symbol, label="@<"}
function day_down:callback()
   day_num = tonumber(day_input.value) - 1
   if day_num < 1 then day_num = 31 end
   day_input.value = format("%02u",day_num)
end
day_up = Button{150,70,25,25;labeltype=Labeltype.symbol, label="@>"}
function day_up:callback()
   day_num = tonumber(day_input.value) + 1
   if day_num > 31 then day_num = 1 end
   day_input.value = format("%02u",day_num)
end

hour_input = Input{60,100,50,25,"Ora:"}
hour_input.value=date("%H")
hour_down = Button{120,100,25,25;labeltype=Labeltype.symbol, label="@<"}
function hour_down:callback()
   hour_num = tonumber(hour_input.value) - 1
   if hour_num < 0 then hour_num = 23 end
   hour_input.value = format("%02u",hour_num)
end
hour_up = Button{150,100,25,25;labeltype=Labeltype.symbol, label="@>"}
function hour_up:callback()
   hour_num = tonumber(hour_input.value) + 1
   if hour_num > 23 then hour_num = 0 end
   hour_input.value = format("%02u",hour_num)
end

min_input = Input{60,130,50,25,"Min:"}
min_input.value=date("%M")
min_down = Button{120,130,25,25;labeltype=Labeltype.symbol, label="@<"}
function min_down:callback()
   min_num = tonumber(min_input.value) - 1
   if min_num < 0 then min_num = 59 end
   min_input.value = format("%02u",min_num)
end
min_up = Button{150,130,25,25;labeltype=Labeltype.symbol, label="@>"}
function min_up:callback()
   min_num = tonumber(min_input.value) + 1
   if min_num > 59 then min_num = 0 end
   min_input.value = format("%02u",min_num)
end

ok = Button{60,160,70,25,"&OK"}
function ok:callback()
  print("Results: "..month_input.value..day_input.value..hour_input.value..min_input.value..year_input.value) 
  execute("sudo date "..month_input.value..day_input.value..hour_input.value..min_input.value..year_input.value) 
  execute("sudo hwclock --systohc")
  fl_alert("Restart Window Manager: Apps->WindowManager->Restart")
  exit(0)
end

w:end_layout()
w:show()
