#!/bin/flua

-- (c) 2005 Robert Shingledecker
-- Icon Tool

dofile("/etc/init.d/functions.lua")

window_width = 310
window_height = 350
view_port = window_height-35

sep = "/"
icontable = {}
lnk_table = {}
listname = tmpname()
shortlistname = tmpname()

Fl_Browser.initializers = {textfont=Font.screen}

w = Window{window_width,window_height,"DSL Strumento x Icone"}
function w:callback()
   remove(shortlistname)
   exit(0)
end   
tabs = Tabs{0,0,window_width,window_height; box=Boxtype.thin_up}

pages = {}
numOfPages = 4

for i = 1,numOfPages do
   pages[i] = Group{0,0,window_width,view_port,"Tab"..i}
end

pages[1]:begin_layout()
pages[1].label="Click"
pg1window = Window{0,0,window_width,view_port}

iconGroup = Group{0,0,window_width,125}
iconsBtn = Light_Button{40,50,200,40,"Visualizza Icone";type=Buttontype.radio}
iconsBtn.value = 1
clickValue = 0
function iconsBtn.callback()
   singleClickBtn.value = 1
   clickValue = 0
end   

noIconsBtn = Light_Button{40,100,200,40,"No Icone";type=Buttontype.radio}
function noIconsBtn.callback()
   singleClickBtn.value = 0
   doubleClickBtn.value = 0
   clickValue = 0
end   
iconGroup:end_layout()

clickGroup = Group{0,125,window_width,320}
singleClickBtn = Light_Button{40,150,200,40,"Singolo Click";type=Buttontype.radio}
singleClickBtn.value = 1
clickValue = 0
function singleClickBtn.callback()
   clickValue = 0
end   

doubleClickBtn = Light_Button{40,200,200,40,"Doppio Click";type=Buttontype.radio}
function doubleClickBtn.callback()
   clickValue = 500
end   
clickGroup:end_layout()

ok = Button{120,view_port-33,50,25,"&OK"}
function ok:callback()
  if iconsBtn.value == 1 then
    updateLine(".xtdesktop/xtdeskrc","ClickInterval","  ClickInterval: "..clickValue)
    updateLine(".desktop","icons","icons: 1")
    execute("iconsnap.sh")
  else
    updateLine(".desktop","icons","icons: 0")
    execute("killall -9 xtdesk >/dev/null 2>&1")
  end
  exit(0)
end

pg1window.position = 0
pages[1]:end_layout()

pages[2]:begin_layout()
pages[2].label="Aspetto"
pg2window = Window{0,0,window_width,view_port}

manualBtn = Light_Button{10,20,280,40,"Usa Coordinate X/Y";type=Buttontype.radio}
function manualBtn.callback()
   autoArrange = 0
   autoArrangeGroup:hide()
end   

autoArrangeBtn = Light_Button{10,80,280,40,"Auto Arrangamento Icone:";type=Buttontype.radio}
autoArrangeBtn.value = 1
autoArrange = 1
function autoArrangeBtn.callback()
   autoArrange = 1
   autoArrangeGroup:show()
end   

autoArrangeGroup = Group{0,85,window_width,view_port-35}
cols_input = Input{120,view_port-165,50,25,"Colonne:"}
cols_input.value=4
cols_down = Button{180,view_port-165,25,25;labeltype=Labeltype.symbol, label="@<"}
function cols_down:callback()
   cols_input.value = cols_input.value - 1
end
cols_up = Button{210,view_port-165,25,25;labeltype=Labeltype.symbol, label="@>"}
function cols_up:callback()
   cols_input.value = cols_input.value + 1
end

margin_input = Input{120,view_port-135,50,25,"Margine alto:"}
margin_input.value=5
margin_down = Button{180,view_port-135,25,25;labeltype=Labeltype.symbol, label="@<"}
function margin_down:callback()
   margin_input.value = margin_input.value - 1
end
margin_up = Button{210,view_port-135,25,25;labeltype=Labeltype.symbol, label="@>"}
function margin_up:callback()
   margin_input.value = margin_input.value + 1
end

horz_input = Input{120,view_port-105,50,25,"Orizzontale:"}
horz_input.value=65
horz_down = Button{180,view_port-105,25,25;labeltype=Labeltype.symbol, label="@<"}
function horz_down:callback()
   horz_input.value = horz_input.value - 1
end
horz_up = Button{210,view_port-105,25,25;labeltype=Labeltype.symbol, label="@>"}
function horz_up:callback()
   horz_input.value = horz_input.value + 1
end

vert_input = Input{120,view_port-75,50,25,"Verticale:"}
vert_input.value=76
vert_down = Button{180,view_port-75,25,25;labeltype=Labeltype.symbol, label="@<"}
function vert_down:callback()
   vert_input.value = vert_input.value - 1
end
vert_up = Button{210,view_port-75,25,25;labeltype=Labeltype.symbol, label="@>"}
function vert_up:callback()
   vert_input.value = vert_input.value + 1
end
autoArrangeGroup:end_layout()

ok = Button{120,view_port-33,50,25,"&OK"}
function ok:callback()
  local filein,err = openfile(".xtdesktop/xtdeskrc","r")
  if not filein then
    fl_alert("Cannot open xtdeskrc! "..err)
    exit(1)
  end
  local data = read(filein,"*a")
  closefile(filein)
  datalen = strlen(data)
  local fileout,err = openfile(".xtdesktop/xtdeskrc","w")
  if not fileout then
    fl_alert("Cannot open xtdeskrc!")
    exit(1)
  end
  local i = 1
  while i < datalen do
    j,k = strfind(data,"\n",i)
    line = strsub(data,i,j-1)
    if strfind(line,"Cols:") then
       if autoArrange == 0 then cols_input.value=0 end
       line = "  Cols: "..cols_input.value
    end
    if autoArrange == 1 then
       if strfind(line,"Width:") then
          line = "  Width: "..horz_input.value
       end
       if strfind(line,"Height:") then
          line = "  Height: "..vert_input.value
       end
       if strfind(line,"TopMargin:") then
          line = "  TopMargin: "..margin_input.value
       end
    end
    write(fileout,line.."\n")
    i = j + 1
  end
  closefile(fileout)
  execute("iconsnap.sh")
  exit(0)
end

helpBtn = Button{250,view_port-35,50,25,"Aiuto"}
function helpBtn.callback()
   fl_message("X assengnare manualmente le coordinate X/Y, Clicca col tasto destro su di una icona, seleziona propriet e modifica il file apertosi." )
end

pg2window.position = 0
pages[2]:end_layout()

pages[3]:begin_layout()
pages[3].label="Aggiungi"
pg3window = Window{0,0,window_width,view_port}

execute('ls -1 .xtdesktop/[a-z]*.png >'..listname ..' 2>/dev/null')
execute('ls -1 .xtdesktop/[a-z]*.gif >>'..listname ..' 2>/dev/null')

local listitems,err = openfile(listname,"r")
if not listitems then
   print("Cannot open file "..listname..": "..err)
   exit(1)
end

local shortlistitems,err = openfile(shortlistname,"w")
if not shortlistitems then
   print("Cannot open file "..shortlistname..": "..err)
   exit(1)
end
local infoitem = read(listitems,"*l")
while infoitem do
   tinsert(icontable,infoitem)
   basename = tailString(infoitem,sep)
   write(shortlistitems,basename.."\n")
   infoitem = read(listitems,"*l")
end
closefile(listitems)
remove(listname)
closefile(shortlistitems)

separator=Box{1,view_port-50,window_width-2,8,"@line"; labeltype=Labeltype.symbol}

selector = Select_Browser{0,0,310,200; type=Browsertype.hold}
function selector:callback()
   selected_item = icontable[self.value]
end
if not selector:load(shortlistname) then
   print("can't load ", shortlistname)
   exit(1)
end

iconLabel_input = Input{80,210,100,25,"Testo:"}
iconX_input = Input{200,210,40,25,"X:"}
iconY_input = Input{260,210,40,25,"Y:"}
fullPath_input = Input{80,240,220,25,"Percorso:"}

addOk = Button{120,view_port-35,50,25,"&OK"}
function addOk.callback()
   if selected_item == nil then
      fl_alert("Devi scegliere un'icona!")
      return
   end
   if iconLabel_input.value == "" then
      fl_alert("Devi insrerire un testo x l'icona!")
      return
   end
   if strfind(iconLabel_input.value," ") then
      fl_alert("Non sono xmessi spazi!")
      return
   end
   if strfind(iconLabel_input.value,"/") then
      fl_alert("No  xmessa la /!")
      return
   end
   if fullPath_input.value == "" then
      fl_alert("Devi inserire il percorso!")
      return
   end
   if iconX_input.value == "" then iconX_input.value = 0 end
   if iconY_input.value == "" then iconY_input.value = 0 end
   local fileout,err = openfile(".xtdesktop/"..iconLabel_input.value..".lnk","w")
   if not fileout then
      fl_alert("Cannot open "..iconLabel_input.value)
      exit(1)
   end
   write(fileout,"table Icon\n")
   write(fileout," Type: Program\n")
   write(fileout," Caption: "..iconLabel_input.value.."\n")
   write(fileout," Command: "..fullPath_input.value.."\n")
   write(fileout," Icon: "..selected_item.."\n")
   write(fileout," X: "..iconX_input.value.."\n")
   write(fileout," Y: "..iconY_input.value.."\n")
   write(fileout," Status: anchor\n")
   write(fileout,"end\n")
   closefile(fileout)
   execute("iconsnap.sh")
   exit(0)
end

helpBtn = Button{250,view_port-35,50,25,"Aiuto"}
function helpBtn.callback()
   fl_message("1. Seleziona un' icona attraverso il nome.\n2. Inserisci il testo che dovr apparire sotto l'icona\n3. Inserisci le coordinate X & Y.\n4. Inserisci il percorso completo dell'eseguibile.")
end

selector.position = 0

pg3window.position = 0
pages[3]:end_layout()

pages[4]:begin_layout()
pages[4].label="Rimuovi"
pg4window = Window{0,0,window_width,view_port}

execute('ls -1 .xtdesktop/*.lnk >'..listname)

separator=Box{1,view_port-50,window_width-2,8,"@line"; labeltype=Labeltype.symbol}

selector = Select_Browser{0,0,310,260; type=Browsertype.hold}
function selector:callback()
   selected_item = selector:text(self.value)
   selected_index = self.value
end
if not selector:load(listname) then
   print("can't load ", listname)
   exit(1)
end

delOk = Button{120,view_port-35,50,25,"&OK"}
function delOk.callback()
   if selected_item == nil then
      fl_alert("Devi scegliere un'icona!")
   else
      selector:remove(selected_index)
      base_item = tailString(selected_item,"/")
      if execute("ls /etc/skel/.xtdesktop/"..base_item.." 2>/dev/null")~=0 then
         remove(selected_item)
      else
         rename(selected_item,selected_item..".hide")
      end
      execute("iconsnap.sh")
      selected_item = nil
   end
end

helpBtn = Button{250,view_port-35,50,25,"Aiuto"}
function helpBtn.callback()
   fl_message("Selezionare il collegamento all'icona.\n Premi il bottone rimuovi icona.")
end

selector.position = 0

pg4window.position = 0
pages[4]:end_layout()

for i = 1,numOfPages do
   tabs:add(pages[i])
end

tabs:end_layout()

w.resizeable = w
w:end_layout()
w:show()
