#!/bin/flua

-- (c) 2005 Robert Shingledecker
-- System Stats 
readfrom("/usr/share/doc/dsl/release.txt")
release = read()
readfrom()
writeto("/tmp/stats.txt")
write("\t"..release.." "..date().."\n")
writeto()
remove("stats.txt")

window_width = 600
window_height = 350
view_port = window_height-35

Fl_Browser.initializers = {textfont=Font.courier}

w = Window{window_width,window_height,"DSL Statistiche d Sistema"}
function w:callback()
   remove("/tmp/stats.txt")
   exit(0)
end   
tabs = Tabs{0,0,window_width,window_height; box=Boxtype.thin_up}

pages = {}
numOfPages = 11

for i = 1,numOfPages do
   pages[i] = Group{0,0,window_width,view_port,"Tab"..i}
end

pages[1]:begin_layout()
pages[1].label="cpu"
pg1browser = Browser{0,0,window_width,view_port}
execute('cat /proc/cpuinfo >> /tmp/stats.txt')
execute('cat /tmp/stats.txt >> stats.txt')
if not pg1browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg1browser.position = 0
pages[1]:end_layout()

pages[2]:begin_layout()
pages[2].label="mem"
pg2browser = Browser{0,0,window_width,view_port}
execute('cat /proc/meminfo | tee /tmp/stats.txt >> stats.txt')
if not pg2browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg2browser.position = 0
pages[2]:end_layout()

pages[3]:begin_layout()
pages[3].label="rete"
pg3browser = Browser{0,0,window_width,view_port}
execute('cat /etc/sysconfig/netcard > /tmp/stats.txt')
execute('cat /etc/resolv.conf >> /tmp/stats.txt')
execute('ifconfig >> /tmp/stats.txt')
execute('cat /tmp/stats.txt >> stats.txt')
if not pg3browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg3browser.position = 0
pages[3]:end_layout()

pages[4]:begin_layout()
pages[4].label="moduli"
pg4browser = Browser{0,0,window_width,view_port}
execute('cat /proc/modules | tee /tmp/stats.txt >> stats.txt')
if not pg4browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg4browser.position = 0
pages[4]:end_layout()

pages[5]:begin_layout()
pages[5].label="pci"
pg5browser = Browser{0,0,window_width,view_port}
execute('lspci | tee /tmp/stats.txt  >> stats.txt')
if not pg5browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg5browser.position = 0
pages[5]:end_layout()

pages[6]:begin_layout()
pages[6].label="processi"
pg6browser = Browser{0,0,window_width,view_port}
execute('ps ax | tee /tmp/stats.txt >> stats.txt')
if not pg6browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg6browser.position = 0
pages[6]:end_layout()

pages[7]:begin_layout()
pages[7].label="dmesg"
pg7browser = Browser{0,0,window_width,view_port}
execute('dmesg  | tee /tmp/stats.txt >> stats.txt')
if not pg7browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg7browser.position = 0
pages[7]:end_layout()

pages[8]:begin_layout()
pages[8].label="mounts"
pg8browser = Browser{0,0,window_width,view_port}
execute('mount | tee /tmp/stats.txt  >> stats.txt')
if not pg8browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg8browser.position = 0
pages[8]:end_layout()

pages[9]:begin_layout()
pages[9].label="filesystems"
pg9browser = Browser{0,0,window_width,view_port}
execute('df -h | tee /tmp/stats.txt >> stats.txt')
if not pg9browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg9browser.position = 0
pages[9]:end_layout()

pages[10]:begin_layout()
pages[10].label="hardware"
pg10browser = Browser{0,0,window_width,view_port}
execute('cat /etc/sysconfig/knoppix | tee /tmp/stats.txt >> stats.txt')
if not pg10browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg10browser.position = 0
pages[10]:end_layout()

pages[11]:begin_layout()
pages[11].label="avvio"
pg11browser = Browser{0,0,window_width,view_port}
execute("sed 's/ /\\n/g' /proc/cmdline | tee /tmp/stats.txt >> stats.txt")
if not pg11browser:load("/tmp/stats.txt") then
   print("can't load browser.data")
   exit(1)
end
pg11browser.position = 0
pages[11]:end_layout()

for i = 1,numOfPages do
   tabs:add(pages[i])
end

tabs:end_layout()

w.resizeable = w
w:end_layout()
w:show()
