#!/bin/flua -f

-- (c) 2005 Robert Shingledecker
-- background selector 

dofile("/etc/init.d/functions.lua")

-- Main

sep = "/"
filetable = {}
listname = tmpname()
shortlistname = tmpname()

window_width = 300
window_height = 250

initfile = ".fluxbox/init"
target = "session.screen0.rootCommand:"

execute('ls -1 /usr/share/fluxbox/backgrounds/* >'..listname)
execute('ls -1 .fluxbox/backgrounds/* >>'..listname)

local listitems,err = openfile(listname,"r")
if not listitems then
   print("Cannot open file "..listname..": "..err)
   exit(1)
end

local shortlistitems,err = openfile(shortlistname,"w")
if not shortlistitems then
   print("Cannot open file "..shortlistname..": "..err)
   exit(1)
end
local infoitem = read(listitems,"*l")
while infoitem do
   tinsert(filetable,infoitem)
   basename = tailString(infoitem,sep)
   write(shortlistitems,basename.."\n")
   infoitem = read(listitems,"*l")
end
closefile(listitems)
remove(listname)
closefile(shortlistitems)

w = Window{window_width,window_height,"Sfondi Scrivania"}
separator=Box{1,window_height-50,window_width-2,8,"@line"; labeltype=Labeltype.symbol}
function w:callback()
   remove(shortlistname)
   exit(0)
end

selector = Select_Browser{0,0,300,200; type=Browsertype.hold}
function selector:callback()
   selected_item = filetable[self.value]
end
if not selector:load(shortlistname) then
   print("can't load ", shortlistname)
   exit(1)
end

scaleBtn = Round_Button{10, window_height-45,20,20,"Scala";type=Buttontype.radio}
function scaleBtn.callback()
   imagePosition = "--scale-width=100 --scale-height=100 " 
end   

emblemBtn = Round_Button{10, window_height-25,20,20,"Originale";type=Buttontype.radio}
function emblemBtn.callback()
   imagePosition = "--center-x --center-y --emblem " 
end   

okBtn = Button{90,window_height-35,50,25,"OK"}
function okBtn.callback()
   if selected_item == nil then
      fl_alert("Devi scegliere un'immagine!")
   else
      command = 'xsri '..imagePosition..selected_item
      execute(command)
   end
end

installBtn = Button{140,window_height-35,50,25,"Istalla"}
function installBtn.callback()
   if command == nil then
      fl_alert("Devi scegliere un'immagine e premere OK\no scegliere un colore!")
   else
      execute(command)
      updateLine(initfile,target,target..command)
      writeto(".background")
      write(command)
      remove(shortlistname)
      exit(0)
   end
end

colorBtn = Button{190,window_height-35,50,25,"Colore"}
function colorBtn.callback()
   ok,r,g,b = fl_color_chooser(nil,51,102,153)
   if ok then
      color_selected = format("%X%X%X",r,g,b)
      command = 'xsri --color=#'..color_selected
      execute(command)
   end
end

helpBtn = Button{240,window_height-35,50,25,"Aiuto"}
function helpBtn.callback()
   fl_message("Permette di scegliere lo sfondo della scrivania tra le immagini presenti in \n /usr/share/fluxbox/backgrounds/\n /home/dsl/.fluxbox/backgrounds/")
end

selector.position = 0
scaleBtn.value = 1
imagePosition = "--scale-width=100 --scale-height=100 " 
command = nil
w.resizable = selector
w:show()
