#!/bin/flua -f
-- (c) 2005 Robert Shingledecker
-- GUI front end to Word viewer

function data_check()
  if input.value == "" then return nil end
  local file_check = openfile(input.value,"r")
  if not file_check then return nil end
  return ""
end

function convertFile()
  convertWin = Window{140,50,"Converti"}
  convertBox = Box{4,8,140,1; label=[[Pdf or Postscript?]]}
  pdfBtn = Button{0,25,70,25,"P&df"}
  function pdfBtn:callback()
    execute('/usr/bin/antiword -p letter \'' .. input.value .. '\' > \''.. input.value .. ".ps\'")
    execute('/usr/local/bin/ps2pdf \'' .. input.value .. ".ps\'")
    remove(input.value .. ".ps")
    exit(0)
  end
  psBtn = Button{70,25,70,25,"&Ps"}
  function psBtn:callback()
    execute('/usr/bin/antiword -p letter \'' .. input.value .. '\' > \''.. input.value .. ".ps\'")
    exit(0)
  end
  convertWin:end_layout()
  convertWin:show()
end

if getn(arg) == 1 then
   print(getn(arg))
   default = arg[1]
end

w = Window{320,75,"MSDoc Convertitore/Visualizzatore"}
input = Input{60,10,210,25,"File:"}
input.value = arg[1]

selectBtn = Button{20,40,70,25,"&Seleziona"}
function selectBtn:callback()
  doc_filename = fl_file_chooser("doc files","*.doc","")
  input.value = doc_filename
end

help = Button{90,40,70,25,"&Aiuto"}
function help:callback()
  w = Window{300,85,"Aiuto"}
  box = Box{3,3,298,83,[[ DSL Word doc Convertitore Visualizzatore.
Puoi visualizzare un .doc 
e convetirlo in Postscript.]]}
  box.box = Boxtype.up
  box.labelfont = Font.bold
  w:show()
end

convert = Button{160,40,70,25,"&Converti"}
function convert:callback()
  if data_check() then
    convertFile()
  else
    write(strchar(7)) flush()
  end
end

view = Button{230,40,70,25,"&Visualizza"}
function view:callback()
  if data_check() then
    workfile = tmpname()
    execute('/usr/bin/antiword -p letter \'' .. input.value .. '\' > ' .. workfile)
    execute('/usr/local/bin/gvu -geometry 800x600 ' .. workfile) 
    remove(workfile)
    exit(0)
  else
    write(strchar(7)) flush()
  end
end

w:end_layout()
w:show()
